Attribute VB_Name = "modBlockSatz"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!


'###################################################################
'
'     modBlockSatz.bas
'
'     Funktionen fr Blocksatz Print
'
'     (c) peter.k.sauer@web.de   07.2003
'     nur fr den persnlichen nicht gewerblichen Gebrauch
'-------------------------------------------------------------------

Option Explicit

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
                (ByVal hWnd As Long, ByVal wMsg As Long, _
                ByVal wParam As Long, lParam As Any) As Long

Private Const EM_GETLINE = &HC4
Private Const EM_GETLINECOUNT = &HBA
Private Const EM_SCROLLCARET = &HB7
Private Const EM_LINELENGTH = &HC1
Private Const EM_LINEINDEX = &HBB

Private Type PrnFormatType
    Top As Single
    Left As Single
    Width As Single
    Height As Single
End Type
   
Private PrnFormat As PrnFormatType

'Anzahl der Zeilen einer Textbox ausgeben
Public Function TextBoxLineCount(ByRef Tbox As Control) As Long
    TextBoxLineCount = SendMessage(Tbox.hWnd, EM_GETLINECOUNT, 0, 0&)
End Function


'einzelne Line einer (Rich) Textbox ausgeben (Line 0 to n)
Public Function TextBoxLine(ByRef Tbox As Control, _
                    ByVal LineNr As Long) As String

   Dim LineLength As Long
   Dim LineStart As Long
   
    'ermitteln Beginn Zeile und Lnge
    LineStart = SendMessage(Tbox.hWnd, EM_LINEINDEX, LineNr, ByVal 0&)
    LineLength = SendMessage(Tbox.hWnd, EM_LINELENGTH, LineStart, ByVal 0&)

    'aus Textbox separieren
    TextBoxLine = Mid$(Tbox, LineStart + 1, LineLength)
End Function

'Position einer Zeile im Text
Public Function TextboxLineStart(ByRef Tbox As Control, LineNr As Long) As Long
    TextboxLineStart = SendMessage(Tbox.hWnd, EM_LINEINDEX, LineNr, ByVal 0&)
End Function

'Lnge einer Zeile
Public Function TextboxLineLength(ByRef Tbox As Control, LineNr As Long) As Long
    Dim LineChar As Long
    
    LineChar = SendMessage(Tbox.hWnd, EM_LINEINDEX, LineNr, ByVal 0&)
    TextboxLineLength = SendMessage(Tbox.hWnd, EM_LINELENGTH, LineChar, ByVal 0&)
End Function

'Textbox in ein Array ausgeben
Public Function TextboxLinesToArray(Tbox As Control) As String()
    Dim s() As String
    Dim i As Long
    
    i = TextBoxLineCount(Tbox)
    If i = 0 Then
        ReDim s(0)
    Else
        ReDim s(i - 1)
        For i = 0 To UBound(s)
            s(i) = TextBoxLine(Tbox, i)
        Next i
    End If
    
    TextboxLinesToArray = s()
End Function

'Breite fr einen Blocksatz aus einem Array ermitteln
Public Function BlockSatzWidth(prnObj As Object, sString() As String, _
                     FontName As String, FontSize As Long, _
                     FontBold As Boolean) As Single

    Dim MaxWidth As Single, w As Single
    Dim i As Long
    Dim s As String
    
    'Schrift einrichten
    prnObj.FontName = FontName
    prnObj.FontSize = FontSize
    prnObj.FontBold = FontBold
    
    'maximale Breite einer Zeile feststellen
    For i = LBound(sString) To UBound(sString)
        sString(i) = RTrim(sString(i))
        w = prnObj.TextWidth(sString(i))
        
        If w > MaxWidth Then
            MaxWidth = w
        End If
    Next i
    
    BlockSatzWidth = MaxWidth
End Function

'Zeile auf Blocksatzlnge ausdrucken
Public Function BlocksatzZeilePrint(prnObj As Object, sString() As String, _
                        Zeile As Long, StartPosX As Single, _
                        MaxWidth As Single) As Boolean
                         
   Dim s() As String
   Dim tb() As Single
   Dim AnzWorte As Long, AnzPixel As Long
   Dim AnzProWort As Single
   Dim i As Long, j As Long
   Dim w As Single
   Dim x As Single
   Dim PrintDirect As Boolean
   
    'linker Rand
    prnObj.CurrentX = StartPosX
   
    If Len(Trim(sString(Zeile))) = 0 Then
        'nix bei Leerzeile
        PrintDirect = True
    ElseIf Zeile = UBound(sString) Then
        'nix bei letzter Zeile
        PrintDirect = True
    ElseIf Len(Trim(sString(Zeile + 1))) = 0 Then
        'nix wenn Leerzeile folgt
        PrintDirect = True
    End If
        
    w = prnObj.TextWidth(sString(Zeile))
    If w = MaxWidth Then
        'ist breiteste Zeile, drucken und weg
        PrintDirect = True
    End If
   
    If PrintDirect Then
        prnObj.Print sString(Zeile)
        BlocksatzZeilePrint = True
        Exit Function
    End If
   
    'Zeile auf Wrter aufsplitten
    s() = Split(sString(Zeile), Space(1))
    
    'wieviele Wrter insgesamt ohne letztes Wort
    For i = LBound(s) To UBound(s) - 1
        If RTrim(s(i)) > 0 Then
            AnzWorte = AnzWorte + 1
        End If
    Next i
    
    'Breite ohne Optimierung feststellen
    w = prnObj.TextWidth(sString(Zeile))
    
    'Breite eines Pixels auf Scalemode der Ausgabe
    x = prnObj.ScaleX(1, vbPixels, prnObj.ScaleMode)
    
    'bentigte Pixel
    AnzPixel = (MaxWidth - w) \ x
    
    'fr Verteilung
    ReDim tb(UBound(s))
    
    'LeerPixel pro Wort ermitteln
    Do
        For i = UBound(s) - 1 To LBound(s) Step -1
            If Len(s(i)) > 0 Then
                tb(i) = tb(i) + 1
                AnzPixel = AnzPixel - 1
            End If
            
            If AnzPixel = 0 Then
                Exit Do
            End If
        Next i
    Loop
    
    'Ausgabe der einzelnen Wrter
    For i = LBound(s) To UBound(s)
        'Wort mit folgendem Space
        prnObj.Print s(i) & Space(1);
        
        'verschieben um x Pixel
        prnObj.CurrentX = prnObj.CurrentX + (tb(i) * x)
    Next i
    
    'Rcklauf mit Zeilenvorschub
    prnObj.Print ""
    
    BlocksatzZeilePrint = True
End Function
